<?php
/*
Plugin Name: Adsense Share for WPMU
Plugin URI: http://www.ringofblogs.com/
Description: Share Adsense income with your wpmu users. This plugin is based on work done by <a href="http://mikesmullin.com/">Mike Smullin</a>.
Version: 1.1
Author: Elad Salomons
Author URI: http://www.ringofblogs.com
License: License: Free if the ringofblogs.com link is not removed!
Last modified: 01-Oct-2007
*/

function widget_adsense($args) {

	$your_adsense_share = get_site_option('your_adsense_share');
	$your_adsense_code = get_site_option('your_adsense_code');

	extract($args);

	$options = array_merge(widget_adsense_options(), get_option('widget_adsense'));
	unset($options[0]); //returned by get_option(), but we don't need it

	if(rand(1, 100) >= 100 - $your_adsense_share) :
		$options['google_ad_client'] = $your_adsense_code ;
	endif;

	//if the user did not enter his Adsense id use the owner code.
	if(empty($options['google_ad_client'])) :
		$options['google_ad_client'] = $your_adsense_code ;
	endif;

	echo $before_widget . $before_title . $options['Title'] . $after_title; ?>

<!-- Google AdSense -->		
<script type="text/javascript"><!--
<?php 
foreach($options as $key => $value)
	echo "$key = \"$value\";\r\n";
?>//--></script>
<script type="text/javascript"
  src="http://pagead2.googlesyndication.com/pagead/show_ads.js">
</script>
<!-- /Google AdSense -->
<br/>
By <a href="http://www.ringofblogs.com">rob</a>

<?		
		echo $after_widget;
}

function widget_adsense_control() {
	$tmp_options = get_option('widget_adsense');
	if (!is_array($tmp_options))
		$tmp_options = array();
	$options = array_merge(widget_adsense_options(), $tmp_options);
	unset($options[0]);

	if ( $_POST['adsense-submit'] ) {
		foreach($options as $key => $value)
			if(array_key_exists('adsense-'.$key, $_POST))
				$options[$key] = strip_tags(stripslashes($_POST['adsense-'.$key]));

		update_option('widget_adsense', $options);
	}

	foreach($options as $key => $value): ?>
		<p style="text-align:left"><label for="adsense-<?=$key?>"><?=$key?>: <input style="width: 200px;" id="adsense-<?=$key?>" name="adsense-<?=$key?>" type="text" value="<?=htmlspecialchars($value, ENT_QUOTES)?>" /></label></p>
	<? endforeach;
	
	$your_adsense_code = get_site_option('your_adsense_code');
	?>

	<script type="text/javascript"><!--
	google_ad_client = "<? echo $your_adsense_code; ?>";
	google_ad_output = "textlink";
	google_ad_format = "ref_text";
	google_cpa_choice = "CAAQnfzw4AIaCJwZC9ix5DwoKN2uuIEBMAA";
	//-->
	</script>
	<script type="text/javascript" src="http://pagead2.googlesyndication.com/pagead/show_ads.js">
	</script>

	<?
	echo '<input type="hidden" id="adsense-submit" name="adsense-submit" value="1" />';
}

function widget_adsense_init() {

	if ( !function_exists('register_sidebar_widget') )
		return;

    $default_your_adsense_share = get_site_option('your_adsense_share');
    if (!$default_your_adsense_share) {
		update_site_option( "your_adsense_share", 20 );
    }
    $default_your_adsense_code = get_site_option('your_adsense_code');
    if (!$default_your_adsense_code) {
		update_site_option( "your_adsense_code", 'pub-ca-xxx' );
	}

	function widget_adsense_options() {
		return array(
			'Title' => "",
			'google_ad_client' => "",
			'google_ad_width' => 120,
			'google_ad_height' => 240,
			'google_ad_format' => "120x240_as",
			'google_ad_type' => "text",
			'google_ad_channel' => "",
			'google_color_border' => "336699",
			'google_color_bg' => "FFFFFF",
			'google_color_link' => "0000FF",
			'google_color_url' => "008000",
			'google_color_text' => "000000",
		);
	}
	
	register_sidebar_widget('Google AdSense', 'widget_adsense');

	register_widget_control('Google AdSense', 'widget_adsense_control', 220, 100 + 50 * count(widget_adsense_options()));
}

function add_adsense_share_page()
	{
		add_submenu_page('wpmu-admin.php', 'adsense_share', 'Adsense share', 0, 'adsense-share-mu.php', 'adsense_share_page');
	}

function adsense_share_page() {

	$message = null;
	$message_updated = __("Adsense share Options Updated.");

	// update options
	if ($_POST['action'] && $_POST['action'] == 'adsense_share_update') {
		$message = $message_updated;
		update_site_option( "your_adsense_share", $_POST[ 'your_adsense_share' ] );
		update_site_option( "your_adsense_code", $_POST[ 'your_adsense_code' ] );
	}
	?>

	<?php if ($message) : ?>
	<div id="message" class="updated fade"><p><?php echo $message; ?></p></div>
	<?php endif; ?>
	
	<div class=wrap>
	<h2>Adsense Share Options</h2>
	
	<form name="form1" method="POST" action=""> 
	<input type='hidden' name='action' value='siteoptions'>

	<fieldset class="options">
		<tr valign="top"> 
		<th scope="row"><?php _e('Your Adsense share (%):') ?></th> 
		<td><input name="your_adsense_share" type="text" id="your_adsense_share" value="<?php echo get_site_option('your_adsense_share', 20) ?>" size="3" />
		</tr> 
		<br/><br/>
		<tr valign="top"> 
		<th scope="row"><?php _e('Your Adsense code:     ') ?></th> 
		<td><input name="your_adsense_code" type="text" id="your_adsense_code" value="<?php echo get_site_option('your_adsense_code', 'pab-xxxxx') ?>" size="50" />
		</tr> 
		</table>
	</fieldset>

	<p class="submit"> 
	<input type="hidden" name="action" value="adsense_share_update" /> 
	<input type="submit" name="Submit" value="<?php _e('Update Options') ?>" /> 
	</p> 
	</form> 
	</div>
	<?php
}
	
// Run our code later in case this loads prior to any required plugins.
add_action('plugins_loaded', 'widget_adsense_init');
//add_action('admin_menu', array(&$this, 'add_adsense_share_page'));
add_action('admin_menu', 'add_adsense_share_page');

?>
